> ## Documentation Index
> Fetch the complete documentation index at: https://developers.phrase.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Update project pre-translate settings



## OpenAPI

````yaml /openapi/phrase-tms-latest.json put /api2/v4/projects/{projectUid}/preTranslateSettings
openapi: 3.0.0
info:
  description: |-
    Welcome to Phrase's TMS API documentation. 

     Please visit our [help center](https://support.phrase.com/hc/en-us/sections/5709662083612) for more information about the APIs. 

     If you have any questions, please contact [Support](https://support.phrase.com/hc/requests/new). 

     Please, include the `User-Agent` header with the name of your application or project. It might be a good idea to include some sort of contact information as well, so that we can get in touch if necessary. Examples of excellent `User-Agent` headers:
     > User-Agent: Example mobile app (example@phrase.com) <br/> User-Agent: ACME Inc Java 1.8 Client (http://acmeinc.com/contact)
  version: Latest
  title: Phrase TMS API
servers:
  - url: https://cloud.memsource.com/web
security:
  - ApiToken: []
  - OAuth2: []
tags:
  - name: Additional Workflow Step
  - name: Analysis
  - name: Async Request
  - name: Authentication
  - name: Automations
  - name: Bilingual File
  - name: Business Unit
  - name: Buyer
  - name: Client
  - name: Connector
  - name: Conversations
  - name: Cost Center
  - name: Custom Fields
  - name: Custom File Type
  - name: Domain
  - name: Due Date Scheme
  - name: Email Template
  - name: File
  - name: Glossary
  - name: Import settings
  - name: Job
  - name: Language AI
  - name: Language Assets
  - name: Language Quality Assessment
  - name: Machine Translation
  - name: Machine Translation Settings
  - name: Mapping
  - name: Net Rate Scheme
  - name: Notifications
  - name: Price List
  - name: Project
  - name: Project Reference File
  - name: Project Template
  - name: Provider
  - name: Quality Assurance
  - name: Quality Profile
  - name: Quote
  - name: SCIM
  - name: Segment
  - name: Segmentation Rules
  - name: Service
  - name: Spell Check
  - name: SubDomain
  - name: Supported Languages
  - name: Term Base
  - name: Translation
  - name: Translation Memory
  - name: User
  - name: Vendor
  - name: Webhook
  - name: Workflow Step
  - name: Workflow changes
  - name: XML Assistant
paths:
  /api2/v4/projects/{projectUid}/preTranslateSettings:
    put:
      tags:
        - Project
      summary: Update project pre-translate settings
      operationId: updateProjectPreTranslateSettingsV4
      parameters:
        - name: projectUid
          in: path
          required: true
          schema:
            type: string
      requestBody:
        $ref: '#/components/requestBodies/PreTranslateSettingsV4DtoV4'
      responses:
        '200':
          description: successful operation
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PreTranslateSettingsV4DtoV4'
        '400':
          description: Bad request
        '401':
          description: Not authorized
        '403':
          description: Forbidden
        '404':
          description: Resource not found
        '405':
          description: Method not allowed
        '408':
          description: Timeout
        '410':
          description: Gone
        '415':
          description: Unsupported media type
        '429':
          description: Too many requests
        '500':
          description: Internal server error
        '501':
          description: Not implemented
components:
  requestBodies:
    PreTranslateSettingsV4DtoV4:
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/PreTranslateSettingsV4DtoV4'
  schemas:
    PreTranslateSettingsV4DtoV4:
      type: object
      properties:
        machineTranslationSettings:
          $ref: >-
            #/components/schemas/PreTranslateSettingsV4DtoMachineTranslationSettingsDtoV4
        nonTranslatableSettings:
          $ref: >-
            #/components/schemas/PreTranslateSettingsV4DtoNonTranslatableSettingsDtoV4
        overwriteExistingTranslations:
          type: boolean
          description: 'Overwrite existing translations in target segments. Default: false'
        preTranslateOnJobCreation:
          type: boolean
          description: >-
            Pre-translate & set job to completed: Pre-translate on job creation.
            Default: false
        pseudoTranslateSettings:
          $ref: >-
            #/components/schemas/PreTranslateSettingsV4DtoPseudoTranslateSettingsDtoV4
        repetitionsSettings:
          $ref: >-
            #/components/schemas/PreTranslateSettingsV4DtoRepetitionsSettingsDtoV4
        setJobStatusCompleted:
          type: boolean
          description: >-
            Pre-translate & set job to completed: Set job to completed once
            pre-translated. Default: false
        setJobStatusCompletedWhenConfirmed:
          type: boolean
          description: >-
            Pre-translate & set job to completed when all segments confirmed:

            Set job to completed once pre-translated and all segments are
            confirmed. Default: false
        setProjectStatusCompleted:
          type: boolean
          description: >-
            Pre-translate & set job to completed: Set project to completed once
            all jobs pre-translated.
                    Default: false
        translationMemorySettings:
          $ref: >-
            #/components/schemas/PreTranslateSettingsV4DtoTranslationMemorySettingsDtoV4
      description: Pre-translate settings
    PreTranslateSettingsV4DtoMachineTranslationSettingsDtoV4:
      type: object
      properties:
        confirmMatches:
          type: boolean
          description: |-
            Set segment status to confirmed for:
                            machine translation suggestions above `confirmMatchesThreshold`. Default: false
        confirmMatchesThreshold:
          type: number
          format: double
          description: 'Machine translation suggestions percent. Default: `1.0`'
          minimum: 0
          maximum: 1
          exclusiveMinimum: false
          exclusiveMaximum: false
        lock100PercentMatches:
          type: boolean
          description: >-
            Lock section: 100% machine translation suggestions. Default: false,
            use lockMtThreshold to override the threshold
        lockMtThreshold:
          type: number
          format: double
          description: >-
            Segment locking based on machine translation suggestions with QPS
            above threshold. Default: 100%, used in combination with
            lock100PercentMatches
          minimum: 0
          maximum: 100
          exclusiveMinimum: false
          exclusiveMaximum: false
        lockPassedQualityEvaluation:
          type: boolean
          description: >-
            Use Quality profile to evaluate and lock segments. Only supported
            for jobs in the first workflow step. Default: false
        machineTranslationBehavior:
          type: string
          description: 'Machine translation behavior. Default: APPLY_MT_ABOVE_THRESHOLD'
          enum:
            - APPLY_MT_ABOVE_THRESHOLD
            - COMPARE_AND_BEST_MATCH
        mtForTMAbove100:
          type: boolean
          description: >-
            Use machine translation for segments with a TM match of 100% or
            more. Default: false
        mtQeMatchesInEditors:
          type: boolean
          description: >-
            Display quality-estimated machine translation suggestions in the CAT
            Editor. Default: false
        mtSuggestOnlyTmBelow:
          type: boolean
          description: 'Suggest MT only for segments with a TM match below. Default: true'
        mtSuggestOnlyTmBelowThreshold:
          type: number
          format: double
          description: >-
            Suggest MT only for segments with a TM match below threshold.
            Default: 1.0
          minimum: 0
          maximum: 1.01
          exclusiveMinimum: false
          exclusiveMaximum: false
        qualityProfileUid:
          type: string
          description: >-
            Quality profile UID (required when lockPassedQualityEvaluation is
            true, max length 32).
          minLength: 0
          maxLength: 32
        useAltTransOnly:
          type: boolean
          description: >-
            Do not put machine translations to target and use alt-trans fields
            (alt-trans in mxlf).

            Default: false
        useMachineTranslation:
          type: boolean
          description: 'Pre-translate from machine translation. Default: false'
      description: Machine translation related settings
    PreTranslateSettingsV4DtoNonTranslatableSettingsDtoV4:
      type: object
      properties:
        confirm100PercentMatches:
          type: boolean
          description: >-
            Set segment status to confirmed for: 100% non-translatables.
            Default: false
        lock100PercentMatches:
          type: boolean
          description: 'Lock section: 100% non-translatables. Default: false'
        nonTranslatablesInEditors:
          type: boolean
          description: If non-translatables are enabled in Editors.
        preTranslateNonTranslatables:
          type: boolean
          description: 'Pre-translate non-translatables. Default: false'
      description: Non-translatables related settings
    PreTranslateSettingsV4DtoPseudoTranslateSettingsDtoV4:
      type: object
      properties:
        keyHashPrefixLen:
          type: integer
          format: int32
          minimum: 0
          maximum: 18
        length:
          type: number
          format: double
          description: 'Target segment length (%). Supported values: 0.1, 0.5 ... 1.5, 2.0'
          minimum: 0.1
          maximum: 2
          exclusiveMinimum: false
          exclusiveMaximum: false
        prefix:
          type: string
        pseudoTranslateIntersperse:
          type: boolean
          description: 'Mix with source text. Default value: true'
        pseudoTranslateSubstitution:
          type: string
          description: 'Comma separated list of character map. Example: aá,Bβ,cć,DĎ,eë'
          minLength: 0
          maxLength: 100
        replacement:
          type: string
          description: Pseudo-translate using
          minLength: 1
          maxLength: 10
        suffix:
          type: string
      description: Pseudo translate related settings
    PreTranslateSettingsV4DtoRepetitionsSettingsDtoV4:
      type: object
      properties:
        autoPropagateRepetitions:
          type: boolean
          description: 'Propagate repetitions. Default: false'
        autoPropagateToLockedRepetitions:
          type: boolean
          description: >-
            Changes in 1st repetition propagate upon confirmation into
            subsequent locked repetitions. Default: false
        confirmRepetitions:
          type: boolean
          description: 'Set segment status to confirmed for: Repetitions. Default: false'
        lockSubsequentRepetitions:
          type: boolean
          description: >-
            If auto-propagated subsequent repetitions should be locked. Default:
            false
      description: Repetitions related settings
    PreTranslateSettingsV4DtoTranslationMemorySettingsDtoV4:
      type: object
      properties:
        confirm100PercentMatches:
          type: boolean
          description: >-
            Set segment status to confirmed for: 100% translation memory
            matches. Default: false
        confirm101PercentMatches:
          type: boolean
          description: >-
            Set segment status to confirmed for: 101% translation memory
            matches. Default: false
        lock100PercentMatches:
          type: boolean
          description: 'Lock section: 100% translation memory matches. Default: false'
        lock101PercentMatches:
          type: boolean
          description: 'Lock section: 101% translation memory matches. Default: false'
        translationMemoryThreshold:
          type: number
          format: double
          description: Pre-translation threshold percent
          minimum: 0
          maximum: 1.01
          exclusiveMinimum: false
          exclusiveMaximum: false
        useTranslationMemory:
          type: boolean
          description: 'Pre-translate from translation memory. Default: false'
      description: Translation memory related settings
  securitySchemes:
    ApiToken:
      description: >-
        Get a token from `auth/login` [endpoint](#operation/login) and then pass
        it in the `Authorization` HTTP header in every subsequent API call. For
        more information visit our [help
        center](https://support.phrase.com/hc/en-us/articles/5709662181404-API-Authentication-TMS-#token-0-0).
      type: apiKey
      name: Authorization
      in: header
    OAuth2:
      description: >-
        A standard OAuth 2.0 authorization code flow. For more information visit
        our [help
        center](https://support.phrase.com/hc/en-us/articles/5709662181404-API-Authentication-TMS-#oauth-2-0-0-1).
      type: oauth2
      flows:
        authorizationCode:
          authorizationUrl: https://cloud.memsource.com/web/oauth/authorize
          tokenUrl: https://cloud.memsource.com/web/oauth/token
          scopes: {}

````